from abaqusGui import *

###########################################################################
# Class definition
###########################################################################

class PmeAssignMaterialDB(AFXDialog):
    
    numInstance = 0
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def __init__(self, modelName):
    
        PmeAssignMaterialDB.numInstance += 1

        self.form = None
        AFXDialog.__init__(self, 'Assign Materials', self.OK|self.CANCEL,
                           DECOR_RESIZE|DIALOG_ACTIONS_SEPARATOR|DIALOG_UNPOST_DESTROY)
        FXMAPFUNC(self, SEL_COMMAND, AFXDialog.ID_CLICKED_OK, PmeAssignMaterialDB.onClick)

        #GUILOG
        getAFXAliasMap().setPrefix(self, 'PmeAssignMaterialDB-%d' % PmeAssignMaterialDB.numInstance)
        #ENDGUILOG
        
        # Set default button
        #
        self.materialBox = AFXComboBox(self, 20, 10, 'Choose Material Name:')
        self.fillBox(modelName)

        getAFXAliasMap().setName(self.materialBox, 'materialBox')

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def initialize(self, form, partNames):
        self.form = form
        self.partNames = partNames
        
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def fillBox(self, modelName):
    
        from kernelAccess import mdb
        model = mdb.models[modelName]
        for materialName in model.materials.keys():
            self.materialBox.appendItem(materialName)
        if len(model.materials.keys()) > 0:
            self.materialBox.setCurrentItem(0)

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onClick(self, sender, sel, ptr):
        if SELID(sel) == AFXDialog.ID_CLICKED_OK:
            material = self.materialBox.getItemText(self.materialBox.getCurrentItem())
            for krow in range(self.form.tableKw.getNumRows()):
                partName = self.form.tableKw.getValue(krow, 2)
                if partName in self.partNames:
                    self.form.tableKw.setValue(krow, 6, material)
            self.hide()
        return 1
