from abaqusGui import *
from abaqusConstants import *

from abq_Pme.pmeConstants import *

###########################################################################
# Class definition
###########################################################################

class PmeAssignThicknessDB(AFXDataDialog):
    
    numInstance = 0
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def __init__(self, form):
    
        PmeAssignThicknessDB.numInstance += 1
        
        self.form = form

        AFXDataDialog.__init__(self, form, 'Assign Thicknesses',
            self.OK|self.APPLY|self.CANCEL,DECOR_RESIZE|DIALOG_ACTIONS_SEPARATOR|DATADIALOG_BAILOUT)

        #GUILOG
        getAFXAliasMap().setPrefix(self, 'PmeAssignThicknessDB-%d' % PmeAssignThicknessDB.numInstance)
        #ENDGUILOG

        pmeModel = mdb.customData.pmeModels[self.form.modelName]
        numRows = len(pmeModel.shellThicknesses)
        numVisRows = min(numRows, 15)
        
        vf = FXVerticalFrame(self, LAYOUT_SIDE_LEFT|LAYOUT_FILL_X)
        hf = FXHorizontalFrame(vf, LAYOUT_FILL_X|FRAME_THICK)
        hf1 = FXHorizontalFrame(hf, LAYOUT_FILL_X|FRAME_THICK)
        self.table = AFXTable(hf1, numVisRows, 2, numRows, 2, self.form.shellThicknessesKw, 0, 
                              LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_THICK|FRAME_SUNKEN|
                              AFXTABLE_NORMAL|AFXTABLE_EDITABLE|AFXTABLE_RESIZE)

        self.table.setLeadingRows(1)
        self.table.showHorizontalGrid(TRUE)
        self.table.showVerticalGrid(TRUE)
        self.table.setColumnType(1,AFXTable.FLOAT)
        self.table.setColumnWidth(0,150)
        self.table.setColumnWidth(1,75)
        self.table.setColumnEditable(0,FALSE)
        self.table.setLeadingRowLabels('Part Name\tThickness')

        for krow in range(numRows):
            partName = pmeModel.shellThicknesses[krow][0]
            thickness = pmeModel.shellThicknesses[krow][1]
            self.form.shellThicknessesKw.setValue(krow, 0, partName)
            self.form.shellThicknessesKw.setValue(krow, 1, '%s' % thickness)

        getAFXAliasMap().setName(self.table, 'table')