from abaqusGui import *

from abq_Pme.pmeConstants import *
from abq_Pme.pmeAssignThicknessDB import PmeAssignThicknessDB

###########################################################################
# Class definition
###########################################################################

class PmeAssignThicknessForm(AFXForm):

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def __init__(self, owner):
        AFXForm.__init__(self, owner)
        self.cmd = AFXGuiCommand(self, "setShellThicknesses", "_UNDEFINED", TRUE)
  
        self.shellThicknessesKw = AFXTableKeyword(self.cmd, 'shellThicknesses', TRUE)
        self.shellThicknessesKw.setColumnType(0, AFXTABLE_TYPE_STRING)
        self.shellThicknessesKw.setColumnType(1, AFXTABLE_TYPE_FLOAT)

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def setPmeModelObj(self, modelName):
    
        from kernelAccess import mdb
        self.pmeModelObj = mdb.customData.pmeModels[self.modelName]
        self.pmeModelObjString = "mdb.customData.pmeModels['%s']" % self.modelName
        self.cmd.setObjectName(self.pmeModelObjString)

     #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def verifyKeywordValues(self):
        # Check weld name
        for krow in range(self.shellThicknessesKw.getNumRows()):
            partName = self.shellThicknessesKw.getValue(krow,0)
            try:
                thickness = self.shellThicknessesKw.getValue(krow,1)
            except:
                msg = "An invalid thickness was specified in row %s." % (krow+1,)
                showAFXErrorDialog(getAFXApp().getAFXMainWindow(), msg)
                return 0
            if thickness <= 0.0:
                msg = "An invalid thickness was specified in row %s." % (krow+1,)
                showAFXErrorDialog(getAFXApp().getAFXMainWindow(), msg)
                return 0
        return 1

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def getFirstDialog(self):
        db = PmeAssignThicknessDB(self)
        return db


