from abaqusGui import *

###########################################################################
# Class definition
###########################################################################

class PmeComboBoxDB(AFXDialog):

    numInstance = 0
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def __init__(self):
    
        PmeComboBoxDB.numInstance += 1
        
        AFXDialog.__init__(self, " ", self.OK|self.CANCEL)

        #GUILOG
        getAFXAliasMap().setPrefix(self, 'PmeComboBoxDB-%d' % PmeComboBoxDB.numInstance)
        #ENDGUILOG

        FXMAPFUNC(self, SEL_COMMAND, AFXDialog.ID_CLICKED_OK, PmeComboBoxDB.onClick)
        
        # Set default button
        #
        vf = FXVerticalFrame(self, LAYOUT_SIDE_LEFT|LAYOUT_FILL_X)
        self.box = AFXComboBox(vf, 30, 15, "")

        getAFXAliasMap().setName(self.box, 'box')

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def initialize(self, mainDB, columnId, partNames, dialogTitle, boxTitle, itemNames):
        self.mainDB = mainDB
        self.columnId = columnId
        self.partNames = partNames
        self.box.setLabelText(boxTitle)
        for itemName in itemNames:
            self.box.appendItem(itemName)
        self.box.setCurrentItem(0)
        self.setTitle(dialogTitle)

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onClick(self, sender, sel, ptr):
        if SELID(sel) == AFXDialog.ID_CLICKED_OK:
            value = self.box.getText()
            for krow in range(self.mainDB.table.getNumRows()):
                partName = self.mainDB.table.getItemText(krow, 1)
                if partName in self.partNames:
                    self.mainDB.table.setItemText(krow, self.columnId, value)
            self.mainDB.updateTableState()
            self.hide()
        return 1
