from symbolicConstants import SymbolicConstant
from abaqusConstants import *

# Default part name suffix
#
partSuffix = '_mp'

STATUS = SymbolicConstant('STATUS')
NAME = SymbolicConstant('NAME')
TECHNIQUE = SymbolicConstant('TECHNIQUE')
ELEMSHAPE = SymbolicConstant('ELEMSHAPE')
GENERATIONMETHOD = SymbolicConstant('GENERATIONMETHOD')
GEOMETRICORDER = SymbolicConstant('GEOMETRICORDER')
FORMULATION = SymbolicConstant('FORMULATION')
ELEMSIZE = SymbolicConstant('ELEMSIZE')
RIGID = SymbolicConstant('RIGID')
SKIN = SymbolicConstant('SKIN')
MATERIAL = SymbolicConstant('MATERIAL')
THICKNESS = SymbolicConstant('THICKNESS')
VOLUME = SymbolicConstant('VOLUME')
ERRORS = SymbolicConstant('ERRORS')
WARNINGS = SymbolicConstant('WARNINGS')
MASS = SymbolicConstant('MASS')
TIMEINCREMENT = SymbolicConstant('TIMEINCREMENT')

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def getReverse(d):
    rev = {}
    for key,value in d.items():
        rev[value] = key
    return rev

fullColIdToColTypeMap = {0:STATUS,
                         1:NAME,
                         2:TECHNIQUE,
                         3:ELEMSHAPE,
                         4:GENERATIONMETHOD,
                         5:GEOMETRICORDER,
                         6:FORMULATION,
                         7:ELEMSIZE,
                         8:MATERIAL,
                         9:ERRORS,
                         10:WARNINGS,
                         11:RIGID,
                         12:SKIN,
                         13:THICKNESS,
                         14:VOLUME,
                         }
fullColTypeToColIdMap = getReverse(fullColIdToColTypeMap)


STANDARD_FORMULATION = SymbolicConstant('STANDARD_FORMULATION')
INCOMPATIBLE_FORMULATION = SymbolicConstant('INCOMPATIBLE_FORMULATION')
REDUCED_FORMULATION = SymbolicConstant('REDUCED_FORMULATION')
HYBRID_FORMULATION = SymbolicConstant('HYBRID_FORMULATION')
REDUCED_HYBRID_FORMULATION = SymbolicConstant('REDUCED_HYBRID_FORMULATION')
INCOMPATIBLE_HYBRID_FORMULATION = SymbolicConstant('INCOMPATIBLE_HYBRID_FORMULATION')
CONTSHELL_FORMULATION = SymbolicConstant('CONTSHELL_FORMULATION')
MODIFIED_FORMULATION = SymbolicConstant('MODIFIED_FORMULATION')
MODIFIED_HYBRID_FORMULATION = SymbolicConstant('MODIFIED_HYBRID_FORMULATION')
IMPROVED_SURFACE_FORMULATION = SymbolicConstant('IMPROVED_SURFACE_FORMULATION')
