from abaqusGui import *

###########################################################################
# Class definition
###########################################################################

class PmeTextFieldDB(AFXDialog):

    numInstance = 0
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def __init__(self):
    
        PmeTextFieldDB.numInstance += 1
        
        AFXDialog.__init__(self, " ", self.OK|self.CANCEL)

        #GUILOG
        getAFXAliasMap().setPrefix(self, 'PmeTextFieldDB-%d' % PmeTextFieldDB.numInstance)
        #ENDGUILOG

        FXMAPFUNC(self, SEL_COMMAND, AFXDialog.ID_CLICKED_OK, PmeTextFieldDB.onClick)
        
        # Set default button
        #
        vf = FXVerticalFrame(self, LAYOUT_SIDE_LEFT|LAYOUT_FILL_X)
        self.text = AFXTextField(vf, 20, " ", None, 0, AFXTEXTFIELD_FLOAT)

        getAFXAliasMap().setName(self.text, 'text')

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def initialize(self, mainDB, columnId, partNames, dialogTitle, gbTitle):
        self.mainDB = mainDB
        self.columnId = columnId
        self.partNames = partNames
        self.text.setLabelText(gbTitle)
        self.text.setText("")
        self.setTitle(dialogTitle)

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onClick(self, sender, sel, ptr):
        if SELID(sel) == AFXDialog.ID_CLICKED_OK:
            value = self.text.getText()
            for krow in range(self.mainDB.table.getNumRows()):
                partName = self.mainDB.table.getItemText(krow, 1)
                if partName in self.partNames:
                    self.mainDB.table.setItemText(krow, self.columnId, value)
            self.mainDB.updateTableState()
            self.hide()
        return 1
