from abaqusGui import *

# Register commands
#
version = '1.1-1'

try:
    import _abqPluginUtils
    status = _abqPluginUtils.checkCompatibility('PartManagerExtension', version)
except:    
    status = 'OK'

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
if status == 'OK':

    author = 'Dassault Systemes Simulia Corp.'
    kernelInitString='import customKernel\n' \
        'from abq_Pme.pmeConstants import *\nimport abq_Pme.pmeModule'
    helpUrl = r'http://abaqus.custhelp.com/cgi-bin/abaqus.cfg/php/' \
               'enduser/std_adp.php?p_faqid=4794'
    description = ''
    buttonText= r'Tools|Part Manager Extension..'
    applicableModules=('Part','Assembly')

    # Use package syntax to avoid possible name clashes with other plugins
    #
    toolset = getAFXApp().getAFXMainWindow().getPluginToolset()
    from abq_Pme.pmeModelForm import PmeModelForm, PmeModelGenericForm
    from abq_Pme.pmeSurfaceProcedure import PmeSurfaceProcedure

    toolset.pmeSurfaceProcedure = PmeSurfaceProcedure(toolset)
    toolset.pmeModelGenericForm = PmeModelGenericForm(toolset)
    form = PmeModelForm(toolset)

    toolset.registerGuiMenuButton(object=form,
                                  buttonText=buttonText,
                                  kernelInitString=kernelInitString,
                                  version=version,
                                  author=author,
                                  applicableModules=applicableModules,
                                  description=description,
                                  helpUrl=helpUrl
                                  )


    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onModuleSwitch(moduleName): 

        # Show dialog in Part or Assembly modules only
        #
        if moduleName in applicableModules:
            if form.getCurrentDialog():
                form.getCurrentDialog().show()
        else:
            if form.getCurrentDialog():
                form.getCurrentDialog().hide()

    setSwitchModuleHook(onModuleSwitch)


else:
    getAFXApp().getAFXMainWindow().writeToMessageArea(status)
    getAFXApp().beep()
